/*
   Projekt z Podstaw Informatyki 2003/2004
   Napisac algorytm i funkcje mnozaca dwie macierze oraz program glowny
   demonstrujacy jej dzialanie.
*/

#include <stdio.h>
#include <conio.h>


void mnozenie_macierzy (int w1, int k1, int w2, int k2); //deklaracja



/* !!!!!!!!!!!!!!!!!!!!! PROGRAM GLOWNY !!!!!!!!!!!!!!!!!!!!!!!!!*/
void main (void)
{
int m1,m2,n1,n2; //zmienne typu calkowitego okreslajace ilosc kolumn w wierszy ma macierzy A i B
int c;


clrscr(); //czyszcze ekran przed wyswietleniem
gotoxy(25,10); //ustawiam kursor w odpowiednim mejscu ekranu


/* Wyswietlam informacje o projekcie */
printf("PROJEKT Z PODSTAW INFORMATYKI\n\n\n\n\r");
printf(" Zadanie 1:\n Napisac algorytm i funkcje mnazaca dwie macierze oraz program glowny \n demonstrujacy jej dzialanie.");
printf("\n\n\n\r Zalozenia:\n Funkcja nie wykorzystuje zadnych zmiennych globalnych,\n umozliwia wykonanie operacji na macierzach o roznych wymiarach");
printf("\n (ustalonych na etapie wywolania funkcji), nie modyfikuje macierzy wejsciowej.\n Program glowny wyswietla dane wejscowe oraz wynikowe w postaci macierzy.\n");
printf("\n\n\n\n\t\t(Nacisnij dowolny klawisz)");
_setcursortype(_NOCURSOR);
/* Koniec wyswietlania informacji */

getch(); //czekam na nacisniecie dowolnego klawisza



   clrscr(); //czyszcze ponownie ekran
   _setcursortype(_NORMALCURSOR); //ustawiam kursor na normalny


   // Wyswietlam na ekranie komunikaty o podanie ilosci wierszy i kolumn macierzy A i B
   printf("\nPODAJ ROZMIAR MACIERZY 'A'\nLiczba wierszy macierzy A: ");
   scanf("%d",&m1);

   printf("Liczba kolumn macierzy  A: ");
   scanf("%d",&n1);


   printf("\nPODAJ ROZMIAR MACIERZY 'B'\nLiczba wierszy macierzy B: ");
   scanf("%d",&m2);

   printf("Liczba kolumn macierzy  B: ");
   scanf("%d",&n2);
   // Koniec wyswietlania informacji


do{
   /* Jezeli chce ponownie wprowadzic dane to ... */
   if (c=='w')
      {
      clrscr(); //czyszcze ponownie ekran
      _setcursortype(_NORMALCURSOR); //ustawiam kursor na normalny

      // Wyswietlam na ekranie komunikaty o podanie ilosci wierszy i kolumn macierzy A i B
      printf("\nPODAJ ROZMIAR MACIERZY 'A'\nLiczba wierszy macierzy A: ");
      scanf("%d",&m1);

      printf("Liczba kolumn macierzy  A: ");
      scanf("%d",&n1);


      printf("\nPODAJ ROZMIAR MACIERZY 'B'\nLiczba wierszy macierzy B: ");
      scanf("%d",&m2);

      printf("Liczba kolumn macierzy  B: ");
      scanf("%d",&n2);
      // Koniec wyswietlania informacji
      }

   if (c == 'k')
      {
      mnozenie_macierzy(m1,n1,m2,n2);
      }

   /* Teraz sprawdzam czy mozliwe jest wymnozenie podanych macierzy.
      Jezeli liczba wierszy macierzy pierwszej A jest rowna liczbie kolumn
      macierzy drugiej B to ... */
   if (n1 == m2)
      {
      /* jezeli zmienne sa takie same to wyswietlam komunikaty o poprawnosci
	 wprowadzonych rozmiarow i o rozmiarze macierzy wyjsciowej */
      clrscr();
      printf("\n\nWymnozenie macierzy o podanych rozmiarach jest mozliwe.\n");
      printf("Macierz po wymnozeniu bedzie miala wymiary %dx%d\n\n\n\r",m1,n2);
      textcolor(WHITE); //zmieniam kolor czcionki na bialy aby ...
      cprintf("          W"); //podswietlic literke "W"
      printf("prowadz ponownie"); //dokanczam napis
      cprintf("          K"); //jak wyrzej z literka "K"
      printf("ontynuuj"); //i dokanczam napis
      cprintf("          Z"); //jak wyrzej z literka "K"
      printf("akoncz"); //i dokanczam napis
      _setcursortype(_NOCURSOR); //ukrywam migajacy kursor
      lowvideo();
      c= getch(); //czekam na wprowadzenie znaku z klawiatury
      }
    else
   /* ... jezeli liczba wierszy macierzy A jest rozna od liczby kolumn macierzy B to mnozenie nie jest mozliwe*/
   if (n1 != m2)
      {
      /* jezeli zmienne sa rozne wykonuje te same czynnosci jak w powyrzszym warunku */
      clrscr();
      printf("\n\nWymnozenie macierzy o podanych rozmiarach jest niemozliwe.\n");
      printf("Liczba wierszy macierzy A musi byc rowna liczbie kolumn macierzy B.\n\n\n\r");
      textcolor(WHITE);
      cprintf("          W");
      printf("prowadz ponownie");
      cprintf("          Z");
      printf("akoncz");
      _setcursortype(_NOCURSOR);
      lowvideo();
      c = getch(); //czekam na wprowadzeni znaku z klawiatury
      }
} while(c!='z');

}
/* !!!!!!!!!!!!!!!!!! KONIEC PROGRAMU GLOWNEGO !!!!!!!!!!!!!!!!!! */





/* !!!!!!!!!! FUNKCJA MNOZACA DWIE MACIERZE !!!!!!!!!! */
void mnozenie_macierzy (int w1, int k1, int w2, int k2)
{
float tab_A[100][100], tab_B[100][100], tab_C[100][100];
int i,j; //zmienne do indeksowania macierzy przy wprowadzaniu danych
int c;
int x,y;
float suma; //zmienna do mnorzenia poszczeglnych element

clrscr(); //czyszcze ponownie ekran
_setcursortype(_NORMALCURSOR); //ustawiam kursor na normalny



/* WPROWADZAMY DANE DO MACIERZY "A" */
//wczytywanie elementow macierzy - wczytuje elementy wierszami
for(i=0;i<w1;i++)
   {
   printf("\nWprowadz elementy %d-go wiersza macierzy 'A'\n",i+1);
   for(j=0;j<k1;j++)
      scanf("%f",&tab_A[i][j]);
   }

/* WPROWADZAMY DANE DO MACIERZY "B" */
//wczytywanie elementow macierzy - wczytuje elementy wierszami
for(i=0;i<w2;i++)
   {
   printf("\nWprowadz elementy %d-go wiersza macierzy 'B'\n",i+1);
   for(j=0;j<k2;j++)
      scanf("%f",&tab_B[i][j]);
   }



/* FUNKCJA MNOZACA MACIERZE */
for(i=0,x=0,y=0,j=0;i<=w1;i++,y=0)
{
	while(y<=k2)
	{
	suma=0;
	x=0;
		for(j=0;j<=k1;j++,x++)
		suma+=tab_A[i][j]*tab_B[x][y];

	tab_C[i][y]=suma;
	y++;
	}
}



       clrscr();
       textcolor(WHITE);
       printf("      Macierz ");
       cprintf("A");
       printf("      Macierz ");
       cprintf("B");
       printf("      Macierz ");
       cprintf("C");
       printf("=A*B");
       cprintf("     W");
       printf("prowadz ponownie\n\n\n\n");
       _setcursortype(_NOCURSOR);
       lowvideo();

do{

  c= getch(); //czekam na wprowadzeni znaku z klawiatury
  if (c == 'a')
     {
       clrscr();
       textcolor(WHITE);
       printf("      Macierz ");
       cprintf("A");
       printf("      Macierz ");
       cprintf("B");
       printf("      Macierz ");
       cprintf("C");
       printf("=A*B");
       cprintf("     W");
       printf("prowadz ponownie\n\n\n\n");
       printf("\n\nMacierz 'A'");
       _setcursortype(_NOCURSOR);
       lowvideo();
     for(i=0;i<w1;i++)
	{
	printf("\n");
	for(j=0;j<k1;j++)
	printf("%8.2f",tab_A[i][j]);
	}
     }
   else
  if (c == 'b')
      {
       clrscr();
       textcolor(WHITE);
       printf("      Macierz ");
       cprintf("A");
       printf("      Macierz ");
       cprintf("B");
       printf("      Macierz ");
       cprintf("C");
       printf("=A*B");
       cprintf("     W");
       printf("prowadz ponownie\n\n\n\n");
       printf("\n\nMacierz 'B'");
       _setcursortype(_NOCURSOR);
       lowvideo();
     for(i=0;i<w2;i++)
	{
	printf("\n");
	for(j=0;j<k2;j++)
	printf("%8.2f",tab_B[i][j]);
	}
      }
   else
  if (c == 'c')
      {
       clrscr();
       textcolor(WHITE);
       printf("      Macierz ");
       cprintf("A");
       printf("      Macierz ");
       cprintf("B");
       printf("      Macierz ");
       cprintf("C");
       printf("=A*B");
       cprintf("     W");
       printf("prowadz ponownie\n\n\n\n");
       printf("\n\nMacierz 'C'");
       _setcursortype(_NOCURSOR);
       lowvideo();
      for(i=0;i<w1;i++)
	{
	printf("\n");
	for(j=0;j<k2;j++)
	printf("%8.2f",tab_C[i][j]);
	}
      }
  }
  while(c!='w');



}
/* !!!!!!!!!! KONIEC !!!!!!!!!! */